// -*- C++ -*-
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Written (W) 2010 Christian Leistner, leisti@gmail.com
 * Copyright (C) 2010 Christian Leistner, Amir Saffari, Samuel Schulter
 *                    Institute for Computer Graphics and Vision,
 *                    Graz University of Technology, Austria
 */

#ifndef BAG_H_
#define BAG_H_

#include <vector>
#include <Eigen/Core>
#include "Sample.h"

using namespace std;
USING_PART_OF_NAMESPACE_EIGEN


class Bag
{
private:
	vector<Sample*> samples_;
	int bag_label_;
public:
	Bag(int label, double weight, MatrixXd sampleData, VectorXi sampleLabels, VectorXd sampleWeights, VectorXi global_sample_index);
	virtual ~Bag();

	vector<Sample*> getSamples() const { return this->samples_; }
	int getNumSamples() const { return (int)this->samples_.size(); }
	int getBagLabel() const { return this->bag_label_; }
};

#endif /* BAG_H_ */
