// -*- C++ -*-
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Written (W) 2010 Christian Leistner, leisti@gmail.com
 * Copyright (C) 2010 Christian Leistner, Amir Saffari, Samuel Schulter
 *                    Institute for Computer Graphics and Vision,
 *                    Graz University of Technology, Austria
 */

#ifndef DATASET_H_
#define DATASET_H_


#include "Sample.h"
#include <vector>

using namespace std;


class Dataset
{
	protected:
		int num_samples_;
		int num_features_;
		int num_classes_;
		vector<Sample*> samples_;

	public:
		Dataset();
		virtual ~Dataset();

		void setSamples( vector< Sample* > new_samples, int num_classes );

		const vector< Sample* > getSamples() { return samples_; }

		inline const int getNumSamples() const { return num_samples_; }

		inline const int getNumFeatures() const { return num_features_; }

		inline const int getNumClasses() const { return num_classes_; }
};

#endif /* DATASET_H_ */
