// -*- C++ -*-
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Written (W) 2010 Christian Leistner, leisti@gmail.com
 * Copyright (C) 2010 Christian Leistner, Amir Saffari, Samuel Schulter
 *                    Institute for Computer Graphics and Vision,
 *                    Graz University of Technology, Austria
 */

#ifndef MILDATASET_H_
#define MILDATASET_H_

#include "Dataset.h"
#include "Bag.h"

class MILDataset: public Dataset
{
	protected:
		int num_bags_;
		vector< Bag* > bags_;

	public:
		MILDataset();
		virtual ~MILDataset();

		void readData( const string& filename_data, const string& filename_samplelabels,
				const string& filename_bag_inst, const string& filename_baglabels );

		void splitDataset( MILDataset& set1, MILDataset& set2, const string& filename_split_set1, const string& filename_split_set2 );

		const vector< Sample* > getSamples();

		inline const vector< Bag* > getBags() const { return bags_; }

		void setBags( vector< Bag* > bags, int num_classes );

		inline const int getNumBags() const { return num_bags_; }
};

#endif /* MILDATASET_H_ */
