// -*- C++ -*-
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Written (W) 2010 Christian Leistner, leisti@gmail.com
 * Copyright (C) 2010 Christian Leistner, Amir Saffari, Samuel Schulter
 *                    Institute for Computer Graphics and Vision,
 *                    Graz University of Technology, Austria
 */

#ifndef RANDOMNODECONFIDENCE_H_
#define RANDOMNODECONFIDENCE_H_

#include "Sample.h"
#include <vector>
#include <Eigen/Core>

USING_PART_OF_NAMESPACE_EIGEN


class RandomNodeConfidence
{
	private:
		int node_label_;
		VectorXd class_confidence_;
		double normalzing_weight_;

	public:
		RandomNodeConfidence() {}
		RandomNodeConfidence( int num_classes );
		virtual ~RandomNodeConfidence();

		void calculateConfidence( const vector<Sample*> samples );
		void refineConfidence( const vector<Sample*> samples );
		double getClassConfidence( int class_index );

		inline VectorXd getClassConfidences() { return class_confidence_; }
};

#endif /* RANDOMNODECONFIDENCE_H_ */
