// -*- C++ -*-
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Written (W) 2010 Christian Leistner, leisti@gmail.com
 * Copyright (C) 2010 Christian Leistner, Amir Saffari, Samuel Schulter
 *                    Institute for Computer Graphics and Vision,
 *                    Graz University of Technology, Austria
 */

#ifndef RANDOMTREE_H_
#define RANDOMTREE_H_

#include "ApplicationParameters.h"
#include "RandomNode.h"
#include "RandomNodeConfidence.h"
#include "RandomForestResult.h"
#include "Sample.h"
#include <vector>

class RandomTree {
private:
	RandomNode* rootNode_;
	int num_classes_;

public:
	RandomTree( int num_features, int num_classes );
	virtual ~RandomTree();

	void train( const vector<Sample*> samples );
	RandomNodeConfidence test( const Sample* sample );
	RandomForestResult test( const vector<Sample*> samples );
	void  refine( const vector<Sample*> samples );
};

#endif /* RANDOMTREE_H_ */
