// -*- C++ -*-
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Written (W) 2010 Christian Leistner, leisti@gmail.com
 * Copyright (C) 2010 Christian Leistner, Amir Saffari, Samuel Schulter
 *                    Institute for Computer Graphics and Vision,
 *                    Graz University of Technology, Austria
 */

#include "Sample.h"
#include "Utilities.h"

Sample::Sample(VectorXd features, const int label, double weight, int global_index)
{
	this->label_ = label;
	this->correct_label_ = label;
	this->weight_ = weight;
	this->features_ = features;
	this->global_index_ = global_index;
}

Sample::Sample( VectorXd features, int label, int correct_label, double weight, int global_index )
{
	this->label_ = label;
	this->correct_label_ = correct_label;
	this->weight_ = weight;
	this->features_ = features;
	this->global_index_ = global_index;
}

Sample::~Sample()
{
}

VectorXd Sample::getFeatures(VectorXi feature_indices) const
{
	int num_features = feature_indices.size();

	VectorXd returnVector = VectorXd::Zero(num_features);

	for (int f = 0; f < num_features; f++)
		returnVector(f) = this->features_(feature_indices(f));

	return returnVector;
}

void Sample::diceNewLabel()
{
	double p = randDouble();
	if (this->label_probabilities_(0) > p)
		this->label_ = 0;
	else
		this->label_ = 1;
}
